package providerapi.com.unitech.utility;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.ActivityNotFoundException;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.RemoteException;
import android.provider.Settings;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.method.LinkMovementMethod;
import android.text.style.ClickableSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.RelativeSizeSpan;
import android.text.style.StyleSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.unitech.scanner.utility.IMyAidlInterface_IsMainActiviyRunning;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.EnumMap;
import java.util.Hashtable;
import java.util.Locale;

import java.util.Map;
import java.util.Objects;
import java.util.logging.Logger;
import java.util.regex.Pattern;

import static android.content.Intent.FLAG_RECEIVER_REPLACE_PENDING;
import static android.graphics.Color.BLACK;
import static android.graphics.Color.WHITE;




public class MainActivity extends AppCompatActivity implements MainFragment.OnFragmentInteractionListener{
    //==============================================================================================
    private static String TAG = "MainHelpActivity";
    private util_api Util_API;

    //region Define the action string
    private static String API_GET_TARGET_SCANNER_STATUS_REPLY = "unitech.scanservice.bluetooth.get_target_scanner_reply";
    private static String API_GET_CONNECTED_SCANNERS_REPLY = "unitech.scanservice.bluetooth.get_scanners_reply";
    private final String API_GET_PAIRING_BARCODE_REPLY = "unitech.scanservice.bluetooth.get_pairing_barcode_reply";
    private static String API_GET_SCANNER_SERIAL_NUMBER_REPLY = "unitech.scanservice.bluetooth.get_sn_reply";
    private static String API_GET_SCANNER_BLUETOOTH_NAME_REPLY = "unitech.scanservice.bluetooth.get_name_reply";
    private static String API_GET_SCANNER_BLUETOOTH_MAC_REPLY = "unitech.scanservice.bluetooth.get_address_reply";
    private static String API_GET_SCANNER_FIRMWARE_VERSION_REPLY = "unitech.scanservice.bluetooth.get_fw_reply";
    private static String API_GET_BATTERY_REPLY = "unitech.scanservice.bluetooth.get_battery_reply";//8
    private static String API_GET_TRIG_REPLY = "unitech.scanservice.bluetooth.get_trig_reply";
    private static String API_GET_DATA_ACK_REPLY = "unitech.scanservice.bluetooth.get_ack_reply";
    private static String API_GET_AUTO_CONNECTION_REPLY = "unitech.scanservice.bluetooth.get_auto_conn_reply";
    private static String API_GET_CONFIG_REPLY = "unitech.scanservice.bluetooth.get_config_reply";
    private static String API_DATA = "unitech.scanservice.data";                                   //5
    private static String API_DATALENGTH = "unitech.scanservice.datalength";
    private static String API_DATABYTE = "unitech.scanservice.databyte";
    private static String API_DATABYTELENGTH = "unitech.scanservice.databytelength";
    private static String API_DATAALL = "unitech.scanservice.dataall";
    private static String API_GET_BLUETOOTH_SIGNAL_CHECKING_LEVEL_REPLY = "unitech.scanservice.bluetooth.get_bt_signal_checking_level_reply";
    private final String API_FINISH_USU ="unitech.scanservice.bluetooth.exit";
    private final String API_EXPORT_SETTINGS ="unitech.scanservice.bluetooth.export_settings";
    private final String API_IMPORT_SETTINGS ="unitech.scanservice.bluetooth.import_settings";
    private final String API_UPLOAD_ALL_SETTINGS ="unitech.scanservice.bluetooth.upload_all_settings";
    private final String API_DATA_CODETYPE ="com.unitech.bluetooth.dataCodeType";
    private final String API_CHANGE_TO_SSI_FORMAT="com.unitech.bluetooth.changeToSSI";
    private final String API_CHANGE_TO_RAW_FORMAT="com.unitech.bluetooth.changeToRAW";
    private final String API_GET_FORMAT ="com.unitech.bluetooth.getFormat";
    private final String API_GET_FORMAT_REPLY="com.unitech.bluetooth.getFormat_reply";
    private final String API_TARGET_SCANNER="unitech.scanservice.bluetooth.target_scanner_callback";
    //endregion

    //region UI parameter
    //region Txt
    private TextView txt_TriggerStatus;
    private TextView txt_Battery;
    private TextView txt_FirmwareVersion;
    private TextView txt_SerialNumber;
    private TextView txt_BluetoothName;
    private TextView txt_BluetoothMAC;
    private TextView txt_ACKStatus;
    private TextView txt_AutoConnStatus;
    private TextView txt_Data;
    private TextView txt_CodeType;
    private TextView txt_DataLength;
    private TextView txt_DataByte;
    private TextView txt_DataByteLength;
    private TextView txt_DataAll;
    private TextView txt_SetConfigName;
    private TextView txt_SetConfigValue;
    private TextView txt_GetConfigValue;
    private TextView txt_SignalCheckingLevel;
    private TextView txt_targetScanner_sn_callback;
    private TextView txt_targetScanner_connection_status_callback;
    private TextView txt_targetScanner_sn;
    private TextView txt_targetScanner_connection_status;
    //endregion
    //region Spinner
    private Spinner spinner_SerialNumberList;
    private Spinner spinner_DataACK;
    private Spinner spinner_BeetTimes;
    private Spinner spinner_Vibrate;
    private Spinner spinner_LEDColor;
    private Spinner spinner_ConfigName;
    //endregion
    //endregion

    private String selectedSerialNumber;
    Hashtable<String, Integer> ConfigTable = new Hashtable <String, Integer>();

    private boolean configFlag = false; //T: receive only code128 & F: other symbologies

    private MyDialogFragment myDialogFragment = null;

    //LogWrite
    private String localFullPath = Environment.getExternalStorageDirectory() + File.separator + "BTScanner_log.txt";
    //----------------------------------------------------------------------------------------------

    private Handler myHandler = new Handler(new Handler.Callback() {
        @Override
        public boolean handleMessage(Message msg) {
            //Get setting status
            switch (msg.what) {
                case 0:     //Trigger Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.GetTrigger();
                    break;
                case 1:     //Configuration
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.GetConfiguration();
                    break;
                case 2:     //ACK Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.GetACKStatus();
                    break;
                case 3:     //Auto Connection Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.GetAutoConnectionStatus();
                    break;
                case 4:     //Bluetooth Signal Checking Level Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.GetBTSignalCheckingLevel();
                    break;
                case 21:     //Enable ACK Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.SetACKStatus(true);
                    break;

                case 22:     //Disable ACK Status
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        //e.printStackTrace();
                        Log.e(TAG, "Time Out");
                    }
                    Util_API.SetACKStatus(false);
                    break;

            }
            return false;
        }
    });

    //==============================================================================================

    private static MainActivity instance;
    public static Handler handler=null;
    public static MainActivity getInstance(){
        return instance;
    }
    static public String bluetoothAddress=null;
    static public Bitmap Code93BitmapOfAndroidBtMacAddress = null;
    IMyAidlInterface_IsMainActiviyRunning myAidlInterface_isMainActiviyRunning;
    private ServiceConnection mConnection = null;
    final String ACTION = "com.unitech.scanner.utility.IMainActivityRunning";
    static AlertDialog LoadingDialog=null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON, WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        WindowManager.LayoutParams params = getWindow().getAttributes();
        params.screenBrightness = 0.75f;
        getWindow().setAttributes(params);
        mConnection = new ServiceConnection() {
            // Called when the connection with the service is established
            public void onServiceConnected(ComponentName className, IBinder service) {
                // Following the example above for an AIDL interface,
                // this gets an instance of the IRemoteInterface, which we can use to call on the service
                myAidlInterface_isMainActiviyRunning = IMyAidlInterface_IsMainActiviyRunning.Stub.asInterface(service);
                // We want to monitor the service for as long as we are
                // connected to it.
            }

            // Called when the connection with the service disconnects unexpectedly
            public void onServiceDisconnected(ComponentName className) {
                Log.e(TAG, "Service has unexpectedly disconnected");
                myAidlInterface_isMainActiviyRunning = null;
            }
        };
        Intent intent = new Intent();
        intent.setAction(ACTION);
        intent.setPackage("com.unitech.scanner.utility");
        bindService(intent, mConnection, Context.BIND_AUTO_CREATE);
        CheckPermission();
        //------------------------------------------------------------------------------------------
        //region Mapping UI with parameter
        //region Text
        txt_TriggerStatus = findViewById(R.id.txt_triggerStatus);
        txt_Battery = findViewById(R.id.txt_BatteryStatus);
        txt_SerialNumber = findViewById(R.id.txt_ScannerSerialNumber);
        txt_FirmwareVersion = findViewById(R.id.txt_ScannerFirmwareVersion);
        txt_BluetoothName = findViewById(R.id.txt_ScannerBluetoothName);
        txt_BluetoothMAC = findViewById(R.id.txt_ScannerBluetoothAddress);
        txt_ACKStatus = findViewById(R.id.txt_ack_status);
        txt_AutoConnStatus = findViewById(R.id.txt_auto_conn_status);
        txt_CodeType=findViewById(R.id.CodeType_data);
        txt_Data = findViewById(R.id.txt_data);
        txt_DataLength = findViewById(R.id.txt_data_length);
        txt_DataByte = findViewById(R.id.txt_data_byte);
        txt_DataByteLength = findViewById(R.id.txt_data_byte_length);
        txt_DataAll = findViewById(R.id.txt_data_all);
        txt_SetConfigName = findViewById(R.id.txt_set_config_name);
        txt_SetConfigValue = findViewById(R.id.txt_set_config_value);
        txt_GetConfigValue = findViewById(R.id.txt_config_value);
        txt_SignalCheckingLevel = findViewById(R.id.txt_signalLevelStatus);
        txt_targetScanner_sn_callback =findViewById(R.id.targetScanner_sn_callback);
        txt_targetScanner_connection_status_callback =findViewById(R.id.targetScanner_connection_status_callback);
        txt_targetScanner_sn=findViewById(R.id.targetScanner_sn);
        txt_targetScanner_connection_status =findViewById(R.id.targetScanner_connection_status);
        /*
        * private TextView txt_targetScanner_sn_callback;
    private TextView txt_targetScanner_connection_status_callback;*/
        //endregion
        //region Spinner
        spinner_SerialNumberList = findViewById(R.id.spinner_serialnumber);
        spinner_DataACK = findViewById(R.id.spinner_data_ack);
        spinner_BeetTimes = findViewById(R.id.spinner_beep_times);
        spinner_Vibrate = findViewById(R.id.spinner_vibrate);
        spinner_LEDColor = findViewById(R.id.spinner_led_color);
        spinner_ConfigName = findViewById(R.id.spinner_configs);

        spinner_SerialNumberList.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView <?> parent, View view, int position, long id) {
                String serialno=parent.getItemAtPosition(position).toString();
                if (Util_API != null) {
                    if(serialno.contentEquals(""))
                        Util_API.ConnectScanner("None");
                    else
                        Util_API.ConnectScanner(serialno);
                    Log.d(TAG, "SetConnectedScanner  " +serialno);
                }
            }

            @Override
            public void onNothingSelected(AdapterView <?> parent) {

            }
        });

        spinner_ConfigName.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int i, long l) {
                try {
                    txt_GetConfigValue.setText(String.valueOf(ConfigTable.get(spinner_ConfigName.getSelectedItem().toString())));
                } catch (Exception e) {
                    txt_GetConfigValue.setText("");
                }
            }

            @Override
            public void onNothingSelected(AdapterView <?> adapterView) {

            }
        });
        //endregion

        //region Button
        findViewById(R.id.btn_getpairAddress).setOnClickListener(BtnEvent);
        //findViewById(R.id.btn_pair).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_unpair).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_otherActivity).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_enable_trigger).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_disable_trigger).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_get_configuration).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_set_configuration).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_get_scannerinfo).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_enable_ack).setOnClickListener(BtnEvent);
        findViewById(R.id.btn_disable_ack).setOnClickListener(BtnEvent);
        //Start decode
        findViewById(R.id.btn_start_scan).setOnClickListener(BtnEvent);
        //Stop decode
        findViewById(R.id.btn_stop_scan).setOnClickListener(BtnEvent);
        //Enable Auto Conn
        findViewById(R.id.btn_enable_auto_conn).setOnClickListener(BtnEvent);
        //Disable Auto Conn
        findViewById(R.id.btn_disable_auto_conn).setOnClickListener(BtnEvent);
        //Set ACK
        findViewById(R.id.btn_set_indicator).setOnClickListener(BtnEvent);
        //endregion
        //region spinner
        String[] bools = new String[]{"True", "False"};

        ArrayAdapter <String> adapter = new ArrayAdapter <>(MainActivity.this,
                android.R.layout.simple_spinner_dropdown_item, bools);

        spinner_DataACK.setAdapter(adapter);
        //Set beep times
        String[] beeptimes = new String[]{"0", "1", "2", "3"};

        ArrayAdapter <String> beepadapter = new ArrayAdapter<>(MainActivity.this,
                android.R.layout.simple_spinner_dropdown_item, beeptimes);

        spinner_BeetTimes.setAdapter(beepadapter);
        //Set vibrate
        spinner_Vibrate.setAdapter(adapter);
        //Set led color
        String[] leds = new String[]{"No LED", "Red", "Green", "Blue"};

        ArrayAdapter <String> ledadapter = new ArrayAdapter <>(MainActivity.this,
                android.R.layout.simple_spinner_dropdown_item, leds);

        spinner_LEDColor.setAdapter(ledadapter);

        //Normal Level
        findViewById(R.id.btn_normal_level).setOnClickListener(BtnEvent);
        //Higher Level
        findViewById(R.id.btn_higher_level).setOnClickListener(BtnEvent);
        //endregion
        //endregion
        //------------------------------------------------------------------------------------------
        Util_API = new util_api(this);
        //------------------------------------------------------------------------------------------
        InitStorageAPIStatus();
        //-----------------------------------------------------------------------------------------

        handler=new Handler();
        instance=this;
        if(LoadingDialog==null)
        {
            LoadingDialog = new AlertDialog.Builder(this).setView(R.layout.progress_bar).create();
            LoadingDialog.setCancelable(false);
        }
        Intent sendIntent =   getPackageManager().getLaunchIntentForPackage("com.unitech.scanner.utility");
        sendIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
        sendIntent.putExtra("ismoveTaskToBack", true);
        startActivity(sendIntent);



    }

    //============================================ Menu =============================================
//    @Override
//    public boolean onCreateOptionsMenu(Menu menu) {
//        MenuInflater inflater = getMenuInflater();
//        inflater.inflate(R.menu.menu_main, menu);
//        return super.onCreateOptionsMenu(menu);
//    }

//    @Override
//    public boolean onOptionsItemSelected(MenuItem item) {
//
//        switch (item.getItemId()) {
//            case R.id.item_initStatus:
//                InitStorageAPIStatus();
//                return true;
//            default:
//                return super.onOptionsItemSelected(item);
//        }
//    }

    //========================================= Function ===========================================
    private void InitStorageAPIStatus() {
        txt_TriggerStatus.setText("");
        txt_Battery.setText("");
    }

    private String makeRandomLink() {
        StringBuilder str = new StringBuilder();
        for (int i = 0; i < 12; i++) {
            int digit = (int) (Math.random() * 16);
            int temp_digit = (digit < 10) ? (digit + 48) : (digit + 87);
            str.append(Character.toString((char) temp_digit));
        }
        return str.toString();
    }

    private void logWriter(String logText) {

        try {

            File logFile = new File(localFullPath);
            if (!logFile.exists()) {
                try {
                    if (logFile.createNewFile()) {
                        Log.d("mkdir", "Create new file: " + localFullPath);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            Date date = new Date(System.currentTimeMillis());
            final SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss", Locale.getDefault());
            String nowFormat = simpleDateFormat.format(date);

            FileWriter fileWriter = new FileWriter(localFullPath, true);
            BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);
            bufferedWriter.append("[").append(nowFormat).append("] ").append(logText);
            bufferedWriter.newLine();
            bufferedWriter.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void CheckPermission() {
        String PERMISSION_WRITE_STORAGE = "android.permission.WRITE_EXTERNAL_STORAGE";
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if ((ActivityCompat.checkSelfPermission(this, PERMISSION_WRITE_STORAGE) != PackageManager.PERMISSION_GRANTED)
            ) {
                String[] perms = {PERMISSION_WRITE_STORAGE};
                int permsRequestCode = 1;
                requestPermissions(perms, permsRequestCode);
            }
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unbindService(mConnection);
        Intent intent = new Intent();
        intent.setAction(API_FINISH_USU);
        sendBroadcast(intent);
    }

    //==============================================================================================
    private View.OnClickListener BtnEvent = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            switch (v.getId()) {
                //Harvey modify
                case R.id.btn_otherActivity:
                    String urlString = "about:blank";
                    Intent intent = new Intent(Intent.ACTION_VIEW,Uri.parse(urlString));
                    //intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    intent.setPackage("com.android.chrome");
                    try {
                        startActivity(intent);
                    } catch (ActivityNotFoundException ex) {
                        // Chrome browser presumably not installed so allow user to choose instead
                        intent.setPackage(null);
                        startActivity(intent);
                    }
                    break;
                case R.id.btn_unpair:
                    Util_API.Unpair();
                    logWriter("Unpair");
                    Toast.makeText(MainActivity.this, "UnConnect!!!", Toast.LENGTH_SHORT).show();
                    break;
                case R.id.btn_get_scannerinfo:
                    txt_Battery.setText("Unknow");
                    txt_SerialNumber.setText("Unknow");
                    txt_FirmwareVersion.setText("Unknow");
                    txt_BluetoothName.setText("Unknow");
                    txt_BluetoothMAC.setText("Unknow");

                    try {
                        Util_API.GetBattery();
                        Thread.sleep(1000);
                        Util_API.GetScannerSerialNumber();
                        Thread.sleep(1000);
                        Util_API.GetScannerFirmwareVersion();
                        Thread.sleep(1000);
                        Util_API.GetScannerBluetoothMAC();
                        Thread.sleep(1000);
                        Util_API.GetScannerBluetoothName();
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    break;
                case R.id.btn_enable_trigger:
                    txt_TriggerStatus.setText("Checking");
                    Util_API.SetTrigger(true);
                    logWriter("Enable Trigger");
                    myHandler.sendEmptyMessage(0);
                    break;
                case R.id.btn_disable_trigger:
                    txt_TriggerStatus.setText("Checking");
                    Util_API.SetTrigger(false);
                    logWriter("Disable Trigger");
                    myHandler.sendEmptyMessage(0);
                    break;
                case R.id.btn_getpairAddress:
                    //spinner_SerialNumberList.setAdapter(null);
                    //Util_API.GetConnectedScanners();
                    //logWriter("Get Connected Scanners");
                    Util_API.GetTargetScanner();
                    Toast.makeText(MainActivity.this, "Get Target Scanner", Toast.LENGTH_SHORT).show();
                    break;
//                case R.id.btn_pair:
//                    if (spinner_SerialNumberList.getSelectedItem() != null) {
//                        selectedSerialNumber = spinner_SerialNumberList.getSelectedItem().toString();
//                        Util_API.ConnectScanner(selectedSerialNumber);
//                        logWriter("Pair : " + selectedSerialNumber);
//                        Toast.makeText(MainActivity.this, "Connect!?", Toast.LENGTH_SHORT).show();
//                    } else {
//                        Toast.makeText(MainActivity.this, "Please select the list of SN.", Toast.LENGTH_SHORT).show();
//                    }
//                    break;

                case R.id.btn_enable_ack:
                    txt_ACKStatus.setText("Checking");
//                   Util_API.SetACKStatus(true);
                    myHandler.sendEmptyMessage(21);
                    logWriter("Enable ACK");
                    myHandler.sendEmptyMessage(2);
                    break;
                case R.id.btn_disable_ack:
                    txt_ACKStatus.setText("Checking");
//                    Util_API.SetACKStatus(false);
                    myHandler.sendEmptyMessage(22);
                    logWriter("Disable ACK");
                    myHandler.sendEmptyMessage(2);
                    break;
                case R.id.btn_start_scan:
                    //Reset UI
                    txt_Data.setText("");
                    txt_DataLength.setText("");
                    txt_DataByte.setText("");
                    txt_DataByteLength.setText("");
                    txt_DataAll.setText("");

                    Util_API.StartDecode();
                    logWriter("Start Decode");
                    break;
                case R.id.btn_stop_scan:
                    Util_API.StopDecode();
                    logWriter("Stop Decode");
                    break;
                case R.id.btn_enable_auto_conn:
                    txt_AutoConnStatus.setText("Checking");
                    Util_API.SetAutoConnectionStatus(true);
                    logWriter("Enable Auto Connection");
                    myHandler.sendEmptyMessage(3);
                    break;
                case R.id.btn_disable_auto_conn:
                    txt_AutoConnStatus.setText("Checking");
                    Util_API.SetAutoConnectionStatus(false);
                    logWriter("Disable Auto Connection");
                    myHandler.sendEmptyMessage(3);
                    break;
                //Harvey end
//
//                case R.id.btn_set_symbologies:
//                    configFlag = false;
//                    Bundle bundle = new Bundle();
//
//                    bundle.putInt("Picklist Mode", 2);
//                    bundle.putInt("GS1 DataBar Limited", 1);
//                    bundle.putInt("Composite CC-A/B", 1);
//                    bundle.putInt("Inverse 1D", 2);
//                    bundle.putInt("QR Inverse", 2);
//
//                    bundle.putInt("Aztec", 0);
//                    bundle.putInt("Code 128 Min Length", 0);
//                    bundle.putInt("Code 128 Max Length", 37);
//                    bundle.putInt("ISBT 128", 0);
//                    bundle.putInt("Code 39", 0);
//
//                    bundle.putInt("Interleaved 2 of 5", 1);
//                    bundle.putInt("Interleaved 2 of 5 Min Length", 1);
//                    bundle.putInt("Interleaved 2 of 5 Max Length", 10);
//                    bundle.putInt("PDF417", 0);
//                    bundle.putInt("Transmit Code ID Character", 1);
//
//                    Util_API.SetConfiguration(bundle);
//                    logWriter("Set symbologies =" + bundle);
//                    myHandler.sendEmptyMessage(1);
//                    break;
                case R.id.btn_set_configuration:
                    Util_API.SetConfiguration(String.valueOf(txt_SetConfigName.getText()), Integer.valueOf(String.valueOf(txt_SetConfigValue.getText())));
                    Log.d(TAG, "Set Configuration : " + txt_SetConfigName.getText() + txt_SetConfigValue.getText());
                    logWriter("Set Configuration");
                    myHandler.sendEmptyMessage(1);
                    break;
                case R.id.btn_get_configuration:
                    Util_API.GetConfiguration();
                    logWriter("Get Configuration");
                    break;
                case R.id.btn_set_indicator:
                    Bundle indicatorBundle = new Bundle();

                    indicatorBundle.putBoolean("dataACK", spinner_DataACK.getSelectedItem().toString().toLowerCase().equals("true"));
                    indicatorBundle.putInt("beepTime", Integer.valueOf(spinner_BeetTimes.getSelectedItem().toString()));
                    indicatorBundle.putBoolean("vibrate", spinner_Vibrate.getSelectedItem().toString().toLowerCase().equals("true"));

                    if (spinner_LEDColor.getSelectedItem().toString().toLowerCase().equals("no led")) {
                        indicatorBundle.putString("ledColor", "none");
                    } else {
                        indicatorBundle.putString("ledColor", spinner_LEDColor.getSelectedItem().toString().toLowerCase());
                    }
                    Util_API.SetIndicator(indicatorBundle);
                    break;
                case R.id.btn_normal_level:
                    txt_SignalCheckingLevel.setText("Checking");
                    Util_API.SetBTSignalCheckingLevel(0);
                    Log.d(TAG, "Set Normal Signal Checking Level");
                    logWriter("Set Normal Signal Checking Level");
                    myHandler.sendEmptyMessage(4);
                    break;
                case R.id.btn_higher_level:
                    txt_SignalCheckingLevel.setText("Checking");
                    Util_API.SetBTSignalCheckingLevel(1);
                    Log.d(TAG, "Set Higher Signal Checking Level");
                    logWriter("Set Higher Signal Checking Level");
                    myHandler.sendEmptyMessage(4);
                    break;
            }
        }
    };

    //==============================================================================================
    @Override
    public void onResume() {
        super.onResume();

        //region Receiver Filter, Harvey modify for new UBS
        IntentFilter filter = new IntentFilter();
        filter.addAction(API_GET_PAIRING_BARCODE_REPLY);
        filter.addAction(API_GET_TARGET_SCANNER_STATUS_REPLY);
        filter.addAction(API_GET_CONNECTED_SCANNERS_REPLY);
        filter.addAction(API_GET_SCANNER_SERIAL_NUMBER_REPLY);
        filter.addAction(API_GET_SCANNER_BLUETOOTH_NAME_REPLY);
        filter.addAction(API_GET_SCANNER_BLUETOOTH_MAC_REPLY);
        filter.addAction(API_GET_SCANNER_FIRMWARE_VERSION_REPLY);
        filter.addAction(API_GET_BATTERY_REPLY);
        filter.addAction(API_GET_TRIG_REPLY);
        filter.addAction(API_GET_DATA_ACK_REPLY);
        filter.addAction(API_GET_AUTO_CONNECTION_REPLY);
        filter.addAction(API_GET_CONFIG_REPLY);
        filter.addAction(API_DATA);
        filter.addAction(API_DATALENGTH);
        filter.addAction(API_DATABYTE);
        filter.addAction(API_DATABYTELENGTH);
        filter.addAction(API_DATAALL);
        filter.addAction(API_GET_BLUETOOTH_SIGNAL_CHECKING_LEVEL_REPLY);
        filter.addAction(API_DATA_CODETYPE);
        filter.addAction(API_GET_FORMAT_REPLY);
        filter.addAction(API_TARGET_SCANNER);
        registerReceiver(mReceiver, filter);
        //endregion

        try {

            Util_API.GetPairingBarcode();
            //Thread.sleep(1000);
            //GenerateLinkCode();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onPause() {
        super.onPause();
        if (mReceiver != null) {
            try {
                unregisterReceiver(mReceiver);
            } catch (Exception ignored) {

            }
        }
//        if (mThread != null) {
//            mThread.interrupt();
//            mThread = null;
//        }
    }
    private static String guessAppropriateEncoding(CharSequence contents) {
        // Very crude at the moment
        for (int i = 0; i < contents.length(); i++) {
            if (contents.charAt(i) > 0xFF) {
                return "UTF-8";
            }
        }
        return null;
    }
    static Bitmap encodeAsBitmap(String contents, BarcodeFormat format, int img_width, int img_height) throws WriterException {
        String contentsToEncode = contents;
        if (contentsToEncode == null) {
            return null;
        }
        Map<EncodeHintType,Object> hints = null;
        String encoding = guessAppropriateEncoding(contentsToEncode);
        if (encoding != null) {
            hints = new EnumMap<>(EncodeHintType.class);
            hints.put(EncodeHintType.CHARACTER_SET, encoding);
        }
        BitMatrix result;
        try {
            result = new MultiFormatWriter().encode(contentsToEncode, format, img_width, img_height, hints);
        } catch (IllegalArgumentException iae) {
            // Unsupported format
            return null;
        }
        int width = result.getWidth();
        int height = result.getHeight();
        int[] pixels = new int[width * height];
        for (int y = 0; y < height; y++) {
            int offset = y * width;
            for (int x = 0; x < width; x++) {
                pixels[offset + x] = result.get(x, y) ? BLACK : WHITE;
            }
        }

        Bitmap bitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bitmap.setPixels(pixels, 0, width, 0, 0, width, height);
        return bitmap;
    }
    public static boolean GenerateLinkCode() throws WriterException, InterruptedException {
        //Log.d(TAG, "Show_MAC_Address");

        //get local bt address from shared preferences
        final SharedPreferences sharedPreferences=MainActivity.getInstance().getSharedPreferences("MobileInfo",Context.MODE_PRIVATE);
        String PairingBarcodeContentTemp="";
        /*
        do {
            String btAddressFromSharedPreferences=sharedPreferences.getString("btAddress",getString(R.string.DefaultBtAddress));
            PairingBarcodeContentTemp=sharedPreferences.getString("PairingBarcodeContent","");
            Thread.sleep(1000);
        }
        while (PairingBarcodeContentTemp.contentEquals(""));
*/
        //String btAddressFromSharedPreferences=sharedPreferences.getString("btAddress",getString(R.string.DefaultBtAddress));
        PairingBarcodeContentTemp=sharedPreferences.getString("PairingBarcodeContent","");

        final String PairingBarcodeContent= PairingBarcodeContentTemp;
        // barcode data
        String barcode_data = PairingBarcodeContent;
        {
            //barcode_data = PairingBarcodeContent;
            //Log.d(TAG, "MAC:" + bluetoothAddress);//.replace(":", ""));

            String dmiScannerStatus = "";
            Process ifc = null;
            BufferedReader bis = null;
            try {
                ifc = Runtime.getRuntime().exec("getprop persist.sys.product.serialno");
                bis = new BufferedReader(new InputStreamReader(ifc.getInputStream()));
                dmiScannerStatus = bis.readLine();
            }catch(IOException e){
                e.printStackTrace();
            }finally {
                try {
                    if (bis != null) {
                        bis.close();
                    }if(ifc != null) {
                        ifc.destroy();
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            Log.d("doDecode", "dmiScannerStatus = " + dmiScannerStatus);

            // barcode image

            try {
                Code93BitmapOfAndroidBtMacAddress = encodeAsBitmap(barcode_data.replace(":","").toUpperCase(), BarcodeFormat.CODE_93, 150, 150);
                int width = MainActivity.getInstance().getResources().getDisplayMetrics().widthPixels;
                int height = (width* Code93BitmapOfAndroidBtMacAddress.getHeight())/ Code93BitmapOfAndroidBtMacAddress.getWidth();
                Code93BitmapOfAndroidBtMacAddress = Bitmap.createScaledBitmap(Code93BitmapOfAndroidBtMacAddress, width, height, true);
                ImageView image = new ImageView(MainActivity.getInstance());
                image.setImageBitmap(Code93BitmapOfAndroidBtMacAddress);



                MainFragment mainFragment=new MainFragment();
                MainActivity.getInstance().getSupportFragmentManager().beginTransaction()
                        .replace(R.id.settingFrag, mainFragment).commit();
                sharedPreferences.edit().putString("btAddress",bluetoothAddress).commit();
/*
            AlertDialog.Builder builder_generate =
                    new AlertDialog.Builder(this).
                            setMessage(barcode_data.substring(4)).
                            setPositiveButton("OK", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    dialog.dismiss();
                                }
                            }).
                            setCancelable(false).
                            setView(image);
            alertdialog_generate = builder_generate.create();
            alertdialog_generate.setCanceledOnTouchOutside(false);
            alertdialog_generate.setCancelable(false);
*/



            } catch (WriterException e) {
                e.printStackTrace();
            }

        }
        //sharedPreferences.edit().putString("btAddress",bluetoothAddress).commit();
        return true;
    }

    public void onImport(View view) {
        Intent intent = new Intent();
        intent.setAction(API_IMPORT_SETTINGS);
        sendBroadcast(intent);
    }

    public void onExport(View view) {
        Intent intent = new Intent();
        intent.setAction(API_EXPORT_SETTINGS);
        sendBroadcast(intent);
    }

    @Override
    public void onFragmentInteraction(Uri uri) {

    }
    public String byteToHex(byte num) {
        char[] hexDigits = new char[2];
        hexDigits[0] = Character.forDigit((num >> 4) & 0xF, 16);
        hexDigits[1] = Character.forDigit((num & 0xF), 16);
        return new String(hexDigits);
    }
    private BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @SuppressLint("SetTextI18n")
        @Override
        public void onReceive(Context context, Intent mIntent) {
            Log.d(TAG, "mReceiver intent=" + mIntent.getAction());

            //Battery Status
            if (Objects.equals(mIntent.getAction(), API_GET_BATTERY_REPLY)) {
                int data = mIntent.getIntExtra("battery", -1);
                String battery = "";
                switch (data) {
                    case 0:
                        battery = "Charging";
                        break;
                    case 1:
                        battery = "Very Low";
                        break;
                    case 2:
                        battery = "Low";
                        break;
                    case 3:
                        battery = "OK";
                        break;
                    case 4:
                        battery = "Full";
                        break;
                    default:
                        battery = "Unknow";
                        break;
                }
                txt_Battery.setText(battery);
                logWriter("Get Battery = " + battery);
                Log.d(TAG, "API_GET_BATTERY_REPLY data:" + data);
            }

            //Trigger Key Status
            if (Objects.equals(mIntent.getAction(), API_GET_TRIG_REPLY)) {
                Boolean trig = mIntent.getBooleanExtra("trig", true);
                txt_TriggerStatus.setText(String.valueOf(trig));
                Toast.makeText(MainActivity.this, "Trigger Key Status : " + String.valueOf(trig), Toast.LENGTH_SHORT).show();
                Log.d(TAG, "API_GET_TRIG_REPLY trig:" + String.valueOf(trig));
            }

            //Auto Connection Status
            if (Objects.equals(mIntent.getAction(), API_GET_AUTO_CONNECTION_REPLY)) {
                Boolean status = mIntent.getBooleanExtra("autoConn", true);
                txt_AutoConnStatus.setText(String.valueOf(status));
                Toast.makeText(MainActivity.this, "Auto Connection : " + String.valueOf(status), Toast.LENGTH_SHORT).show();
                Log.d(TAG, "API_GET_AUTO_CONNECTION_REPLY trig:" + String.valueOf(status));
            }
            if (Objects.equals(mIntent.getAction(), API_GET_PAIRING_BARCODE_REPLY))
            {

                String PairingBarcodeContent=mIntent.getStringExtra("PairingBarcodeContent");
                Log.d(TAG,"API_GET_PAIRING_BARCODE_REPLY,PairingBarcodeContent="+PairingBarcodeContent);
                if(PairingBarcodeContent!=null)
                {
                    final SharedPreferences sharedPreferences=MainActivity.getInstance().getSharedPreferences(getString(R.string.LocalInfo),Context.MODE_PRIVATE);
                    SharedPreferences.Editor editor = sharedPreferences.edit();
                    editor.putString("PairingBarcodeContent", PairingBarcodeContent);
                    editor.commit();
                    try {
                        MainActivity.GenerateLinkCode();
                    } catch (WriterException e) {
                        e.printStackTrace();
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }

            }
            // Get Target Scanner Status
            if (Objects.equals(mIntent.getAction(), API_GET_TARGET_SCANNER_STATUS_REPLY))
            {
                Boolean isConnected = mIntent.getBooleanExtra("IsConnected", false);
                String sn= mIntent.getStringExtra("serialNo");
                if(sn!=null)
                {
                    //there is value in sn
                    txt_targetScanner_sn.setText(sn);
                }
                if(isConnected)
                    txt_targetScanner_connection_status.setText("connected");
                else
                    txt_targetScanner_connection_status.setText("disconnected");
            }

                //Connected Scanners LIst
            if (Objects.equals(mIntent.getAction(), API_GET_CONNECTED_SCANNERS_REPLY)) {
                String[] scannerList = mIntent.getStringArrayExtra("connectedScanners");
                String[] newScannerList=new String[scannerList.length+1];
                for(int i=0;i<newScannerList.length;i++)
                {
                    if(i==0)
                        newScannerList[i]="";
                    else
                    {
                        newScannerList[i]=scannerList[i-1];
                    }
                }
                if (newScannerList != null) {
                    ArrayAdapter <String> adapter = new ArrayAdapter <>(MainActivity.this,
                            android.R.layout.simple_spinner_dropdown_item, newScannerList);

                    spinner_SerialNumberList.setAdapter(adapter);
                    Log.d(TAG,"scannerList = "+ Arrays.toString(newScannerList));

                    Toast.makeText(MainActivity.this, "Got connected scanners list", Toast.LENGTH_SHORT).show();
                }
            }

            //Serial Number
            if (Objects.equals(mIntent.getAction(), API_GET_SCANNER_SERIAL_NUMBER_REPLY)) {
                String sn = mIntent.getStringExtra("sn");
                txt_SerialNumber.setText(sn);
                Log.d(TAG, "API_GET_SCANNER_SERIAL_NUMBER_REPLY sn:" + sn);
            }

            //Firmware Version
            if (Objects.equals(mIntent.getAction(), API_GET_SCANNER_FIRMWARE_VERSION_REPLY)) {
                String fw = mIntent.getStringExtra("fw");
                txt_FirmwareVersion.setText(fw);
                Log.d(TAG, "API_GET_SCANNER_FIRMWARE_VERSION_REPLY fw:" + fw);
            }

            //Bluetooth Name
            if (Objects.equals(mIntent.getAction(), API_GET_SCANNER_BLUETOOTH_NAME_REPLY)) {
                String name = mIntent.getStringExtra("name");
                txt_BluetoothName.setText(name);
                Log.d(TAG, "API_GET_SCANNER_BLUETOOTH_NAME_REPLY name:" + name);
            }

            //Bluetooth MAC Address
            if (Objects.equals(mIntent.getAction(), API_GET_SCANNER_BLUETOOTH_MAC_REPLY)) {
                String btMAC = mIntent.getStringExtra("address");
                txt_BluetoothMAC.setText(btMAC);
                Log.d(TAG, "API_GET_SCANNER_BLUETOOTH_MAC_REPLY address:" + btMAC);
            }

            //ACK Status
            if (Objects.equals(mIntent.getAction(), API_GET_DATA_ACK_REPLY)) {
                Boolean status = mIntent.getBooleanExtra("ack", true);
                txt_ACKStatus.setText(String.valueOf(status));
                Log.d(TAG, "API_GET_DATA_ACK_REPLY ack:" + status);
            }

            //API_TARGET_SCANNER
            if (Objects.equals(mIntent.getAction(), API_TARGET_SCANNER)) {
                Boolean isConnected = mIntent.getBooleanExtra("IsConnected", false);
                String sn= mIntent.getStringExtra("serialNo");
                if(sn!=null)
                {
                    //there is value in sn
                    txt_targetScanner_sn_callback.setText(sn);
                }
                if(isConnected)
                    txt_targetScanner_connection_status_callback.setText("connected");
                else
                    txt_targetScanner_connection_status_callback.setText("disconnected");
            }

            //SSI code type and data
            if (Objects.equals(mIntent.getAction(), API_DATA_CODETYPE)) {
                byte codeType=mIntent.getByteExtra("codeType", (byte) 0xff);
                if(codeType!=(byte)0xff)
                    txt_CodeType.setText(byteToHex(codeType));
                else
                    txt_CodeType.setText("");
            }
            //region Scan Data
            //Get Format
            if (Objects.equals(mIntent.getAction(), API_GET_FORMAT_REPLY)) {
                final int format=mIntent.getIntExtra("format",-1);
                //Logger.info("format:"+format);
                if(format==0)
                {
                    Toast.makeText(MainActivity.this, "RAW Format", Toast.LENGTH_SHORT).show();
                }
                else if(format==1)
                {
                    Toast.makeText(MainActivity.this, "SSI Format", Toast.LENGTH_SHORT).show();
                }
            }
            //Data
            if (Objects.equals(mIntent.getAction(), API_DATA)) {
                String data = mIntent.getStringExtra("text");
                txt_Data.setText(data);
                logWriter("Get Data = " + data);
                Toast.makeText(MainActivity.this, "API_DATA text:" + data, Toast.LENGTH_SHORT).show();
                Log.d(TAG, "API_DATA data:" + data);
            }

            //Data Length
            if (Objects.equals(mIntent.getAction(), API_DATALENGTH)) {
                int DataLength = mIntent.getIntExtra("text", 0);
                txt_DataLength.setText(String.valueOf(DataLength));
                Log.d(TAG, "API_DATALENGTH text:" + DataLength);
            }

            //Data Byte
            if (Objects.equals(mIntent.getAction(), API_DATABYTE)) {
                byte[] DataByte = mIntent.getByteArrayExtra("text");
                txt_DataByte.setText(Arrays.toString(DataByte));
                Log.d(TAG, "API_DATABYTE text:" + Arrays.toString(DataByte));
            }

            //Data Byte Length
            if (Objects.equals(mIntent.getAction(), API_DATABYTELENGTH)) {
                int DataByteLength = mIntent.getIntExtra("text", 0);
                txt_DataByteLength.setText(String.valueOf(DataByteLength));
                Log.d(TAG, "API_DATABYTELENGTH text:" + DataByteLength);
            }

            //Data All
            if (Objects.equals(mIntent.getAction(), API_DATAALL)) {
                int DataByteLength = mIntent.getIntExtra("databytelength", 0);
                Log.d(TAG, "API_DATAALL databytelength:" + DataByteLength);

                byte[] DataByte = mIntent.getByteArrayExtra("databyte");
                Log.d(TAG, "API_DATAALL databyte:" + Arrays.toString(DataByte));

                txt_DataAll.setText("Data : " + Arrays.toString(DataByte) + " Len : " + DataByteLength);
            }

            //Get Configuration Reply
            if (Objects.equals(mIntent.getAction(), API_GET_CONFIG_REPLY)) {
                ConfigTable.clear();
                spinner_ConfigName.setAdapter(null);

                Bundle bundle = mIntent.getExtras();
                String[] configNameList = new String[bundle.keySet().size()];

                int i = 0;

                if (bundle != null) {
                    for (String key : bundle.keySet()) {
                        Object value = bundle.get(key);
                        configNameList[i++] = key;
                        ConfigTable.put(key, (Integer) bundle.get(key));
                        Log.d(TAG, String.format("%s %s (%s)", key, value.toString(), value.getClass().getName()));
                    }
                }

                if (configNameList.length > 0) {
                    ArrayAdapter <String> adapter = new ArrayAdapter <>(MainActivity.this,
                            android.R.layout.simple_spinner_dropdown_item, configNameList);

                    spinner_ConfigName.setAdapter(adapter);

                    Toast.makeText(MainActivity.this, "Got Configuration list", Toast.LENGTH_SHORT).show();
                }
                Log.d(TAG, configNameList.toString());
            }

            //Get Bluetooth Signal Check Status
            if (Objects.equals(mIntent.getAction(), API_GET_BLUETOOTH_SIGNAL_CHECKING_LEVEL_REPLY)) {
                Integer level = mIntent.getIntExtra("btSignalCheckingLevel", 0);
                txt_SignalCheckingLevel.setText(level == 0 ? "Normal" : "Higher");
                Log.d(TAG, "API_GET_BLUETOOTH_SIGNAL_CHECKING_LEVEL_REPLY btSignalCheckingLeve:" + level);
            }
            //endregion
        }
    };

    public void onUpload(View view) {
        Intent intent = new Intent();
        intent.setAction(API_UPLOAD_ALL_SETTINGS);
        sendBroadcast(intent);
    }

    public void startUSU(View view) {
        if(myAidlInterface_isMainActiviyRunning!=null)
        {
            boolean isRunning=false;
            if (myAidlInterface_isMainActiviyRunning != null && myAidlInterface_isMainActiviyRunning.asBinder().isBinderAlive())
            try {
                isRunning=myAidlInterface_isMainActiviyRunning.isRunning();
            } catch (RemoteException e) {
                e.printStackTrace();
            }
            if(!isRunning)
            {
                Intent sendIntent =   getPackageManager().getLaunchIntentForPackage("com.unitech.scanner.utility");
                sendIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP|Intent.FLAG_ACTIVITY_NEW_TASK);
                sendIntent.putExtra("ismoveTaskToBack", true);
                startActivity(sendIntent);
            }
        }


    }

    public void changeToSSI(View view) {
        this.sendBroadcast(new Intent().setAction(API_CHANGE_TO_SSI_FORMAT).setFlags(FLAG_RECEIVER_REPLACE_PENDING));
    }

    public void changeToRAW(View view) {
        this.sendBroadcast(new Intent().setAction(API_CHANGE_TO_RAW_FORMAT).setFlags(FLAG_RECEIVER_REPLACE_PENDING));
    }

    public void getFormat(View view) {
        this.sendBroadcast(new Intent().setAction(API_GET_FORMAT).setFlags(FLAG_RECEIVER_REPLACE_PENDING));
    }
}
