package providerapi.com.unitech.utility;


import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Typeface;
import android.net.Uri;
import android.os.Bundle;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.method.LinkMovementMethod;
import android.text.style.ClickableSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.RelativeSizeSpan;
import android.text.style.StyleSpan;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.EnumMap;
import java.util.Map;
import java.util.regex.Pattern;

import static android.graphics.Color.BLACK;
import static android.graphics.Color.WHITE;
import static providerapi.com.unitech.utility.MainActivity.Code93BitmapOfAndroidBtMacAddress;
import static providerapi.com.unitech.utility.MainActivity.bluetoothAddress;

public class MainFragment extends Fragment {
    public static String TAG="MainFragment";
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private final String ARG_PARAM1 = "param1";
    private final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    private OnFragmentInteractionListener mListener;
    String guessAppropriateEncoding(CharSequence contents) {
        // Very crude at the moment
        for (int i = 0; i < contents.length(); i++) {
            if (contents.charAt(i) > 0xFF) {
                return "UTF-8";
            }
        }
        return null;
    }
    Bitmap encodeAsBitmap(String contents, BarcodeFormat format, int img_width, int img_height) throws WriterException {
        String contentsToEncode = contents;
        if (contentsToEncode == null) {
            return null;
        }
        Map<EncodeHintType,Object> hints = null;
        String encoding = guessAppropriateEncoding(contentsToEncode);
        if (encoding != null) {
            hints = new EnumMap<>(EncodeHintType.class);
            hints.put(EncodeHintType.CHARACTER_SET, encoding);
        }
        BitMatrix result;
        try {
            result = new MultiFormatWriter().encode(contentsToEncode, format, img_width, img_height, hints);
        } catch (IllegalArgumentException iae) {
            // Unsupported format
            return null;
        }
        int width = result.getWidth();
        int height = result.getHeight();
        int[] pixels = new int[width * height];
        for (int y = 0; y < height; y++) {
            int offset = y * width;
            for (int x = 0; x < width; x++) {
                pixels[offset + x] = result.get(x, y) ? BLACK : WHITE;
            }
        }

        Bitmap bitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bitmap.setPixels(pixels, 0, width, 0, 0, width, height);
        return bitmap;
    }
    private void showChangeBTAddressDialog() {
        LayoutInflater inflater = LayoutInflater.from(MainActivity.getInstance());
        final View v = inflater.inflate(R.layout.bt_address_edittext, null);
        TextView textView = new TextView(MainActivity.getInstance());
        textView.setMovementMethod(LinkMovementMethod.getInstance());
        String tempString=getString(R.string.InputBtAdressTitle);
        SpannableString spanString = new SpannableString(tempString);
        ClickableSpan clickableSpan = new ClickableSpan() {
            @Override
            public void onClick(View widget) {
                Intent intent =  new Intent(Settings.ACTION_DEVICE_INFO_SETTINGS);
                startActivity(intent);
            }
        };
        String clickHere="click here.";
        spanString.setSpan(clickableSpan, tempString.indexOf(clickHere),tempString.indexOf(clickHere)+clickHere.length(), Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
        spanString.setSpan(new StyleSpan(Typeface.NORMAL), 0, spanString.length(), 0);
        //设置字体大小（相对值,单位：像素） 参数表示为默认字体大小的多少倍   ,0.5表示一半
        spanString.setSpan(new RelativeSizeSpan(1.3f), 0, spanString.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        //设置字体前景色
        spanString.setSpan(new ForegroundColorSpan(BLACK), 0, spanString.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);
        spanString.setSpan(new ForegroundColorSpan(Color.BLUE), tempString.indexOf(clickHere),tempString.indexOf(clickHere)+clickHere.length(), Spanned.SPAN_EXCLUSIVE_EXCLUSIVE);

        SharedPreferences sharedPreferences=MainActivity.getInstance().getSharedPreferences(getString(R.string.LocalInfo),Context.MODE_PRIVATE);
        String btAddressFromSharedPreferences=sharedPreferences.getString("btAddress",getString(R.string.DefaultBtAddress));
        EditText editText = (EditText) (v.findViewById(R.id.editTextBtAddress));
        editText.setText(btAddressFromSharedPreferences);
        textView.setText(spanString);
        AlertDialog.Builder builder=new AlertDialog.Builder(MainActivity.getInstance())
                .setCustomTitle(textView)
                .setView(v)
                .setCancelable(false)
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        String macAddressPattern="^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$";
                        EditText editText = (EditText) (v.findViewById(R.id.editTextBtAddress));
                        //Toast.makeText(getApplicationContext(), "你的id是" +editText.getText().toString(), Toast.LENGTH_SHORT).show();
                        bluetoothAddress=editText.getText().toString();
                        if((bluetoothAddress.length()>0 && !Pattern.matches(macAddressPattern, bluetoothAddress)) || bluetoothAddress.length()==0)
                        {
                            //wrong format
                            //Logger.warn("wrong format");
                            showChangeBTAddressDialog();
                            return;
                        }
                        else
                        {
                            //correct format
                            //Logger.warn("correct format");
                        }
                        SharedPreferences sharedPreferences=MainActivity.getInstance().getSharedPreferences(getString(R.string.LocalInfo),Context.MODE_PRIVATE);

                        String barcode_data = "//.USU" + bluetoothAddress;//.replace(":", "");
                        //Log.d(TAG, "MAC:" + bluetoothAddress);//.replace(":", ""));

                        String dmiScannerStatus = "";
                        Process ifc = null;
                        BufferedReader bis = null;
                        try {
                            ifc = Runtime.getRuntime().exec("getprop persist.sys.product.serialno");
                            bis = new BufferedReader(new InputStreamReader(ifc.getInputStream()));
                            dmiScannerStatus = bis.readLine();
                        }catch(IOException e){
                            e.printStackTrace();
                        }finally {
                            try {
                                if (bis != null) {
                                    bis.close();
                                }if(ifc != null) {
                                    ifc.destroy();
                                }
                            } catch (IOException e) {
                                e.printStackTrace();
                            }
                        }
                        Log.d("doDecode", "dmiScannerStatus = " + dmiScannerStatus);

                        // barcode image

                        try {
                            Code93BitmapOfAndroidBtMacAddress = encodeAsBitmap(barcode_data.replace(":","").toUpperCase(), BarcodeFormat.CODE_93, 150, 150);
                            int width = MainActivity.getInstance().getResources().getDisplayMetrics().widthPixels;
                            int height = (width* Code93BitmapOfAndroidBtMacAddress.getHeight())/ Code93BitmapOfAndroidBtMacAddress.getWidth();
                            Code93BitmapOfAndroidBtMacAddress = Bitmap.createScaledBitmap(Code93BitmapOfAndroidBtMacAddress, width, height, true);
                            ImageView image = new ImageView(MainActivity.getInstance());
                            image.setImageBitmap(Code93BitmapOfAndroidBtMacAddress);


                            sharedPreferences.edit().putString("btAddress",bluetoothAddress).commit();
/*
            AlertDialog.Builder builder_generate =
                    new AlertDialog.Builder(this).
                            setMessage(barcode_data.substring(4)).
                            setPositiveButton("OK", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    dialog.dismiss();
                                }
                            }).
                            setCancelable(false).
                            setView(image);
            alertdialog_generate = builder_generate.create();
            alertdialog_generate.setCanceledOnTouchOutside(false);
            alertdialog_generate.setCancelable(false);
*/
                            String API_UNPAIR_MAC = "unitech.scanservice.bluetooth.unpair_mac";
                            Intent intent = new Intent().setAction(API_UNPAIR_MAC);
                            //sendBroadcast(intent);
                            //startScan(null);
                            String START_SCAN = "com.unitech.bluetooth.start_scan";
                            intent = new Intent().setAction(START_SCAN);
                            //sendBroadcast(intent);
                            try {
                                //alertdialog_generate.show();
                            }
                            catch (Exception e) {

                            }
                            MainFragment mainFragment=new MainFragment();
                            MainActivity.getInstance().getSupportFragmentManager().beginTransaction()
                                    .replace(R.id.settingFrag, mainFragment)
                                    .commit();
                        } catch (WriterException ex) {
                            ex.printStackTrace();
                            String error=ex.getStackTrace()[ex.getStackTrace().length-1].getLineNumber()+":"+ex.toString();
                            //Logger.error(error);
                        }

                    }
                });
        if(!MainActivity.getInstance().isFinishing())
            builder.show();
        //show alert let user to input mac address
        Button openStauts=(Button)v.findViewById(R.id.OpenStatusBtn);
        openStauts.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent =  new Intent(Settings.ACTION_DEVICE_INFO_SETTINGS);
                startActivity(intent);
            }
        });
        //sharedPreferences.edit().putString("btAddress",bluetoothAddress).commit();
    }
    public MainFragment() {
        // Required empty public constructor
    }


    // TODO: Rename and change types and number of parameters
    public static MainFragment newInstance() {

        Bundle args = new Bundle();

        MainFragment fragment = new MainFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        //Logger.info(getClass().toString()+":"+"onCreateView");
        return inflater.inflate(R.layout.fragment_main, container, false);
/*
        if (container == null) {
            return null;
        }

        ScrollView ll = (ScrollView )inflater.inflate(R.layout.fragment_main, container, false);
        TextView btMacAdress=ll.findViewById(R.id.BtMacAddress);
        ImageView btQrCode=ll.findViewById(R.id.BtMacAddressCode128);
        //TextView btMacAdress=findViewById(R.id.BtMacAddress);
        btMacAdress.setText(getString(R.string.android_bluetooth_mac_address)+bluetoothAddress);
        //ImageView btQrCode=findViewById(R.id.BtMacAddressQrCode);
        btQrCode.setImageBitmap(Code93BitmapOfAndroidBtMacAddress);
        return ll;
*/
    }
    public View myView;
    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        view.invalidate();
        //Logger.info(getClass().toString()+":"+"onViewCreated");
        myView=view;
        TextView btMacAdress=view.findViewById(R.id.BtMacAddress);
        ImageView btCode93=view.findViewById(R.id.BtMacAddressCode93);

        //TextView btMacAdress=findViewById(R.id.BtMacAddress);
        final SharedPreferences sharedPreferences=MainActivity.getInstance().getSharedPreferences(getString(R.string.LocalInfo),Context.MODE_PRIVATE);
        String PairingBarcodeContentTemp="";
        PairingBarcodeContentTemp=sharedPreferences.getString("PairingBarcodeContent","");
        btMacAdress.setText(PairingBarcodeContentTemp);
        //ImageView btCode128=findViewById(R.id.BtMacAddressQrCode);
        btCode93.setImageBitmap(Code93BitmapOfAndroidBtMacAddress);
        btCode93.setOnLongClickListener(new View.OnLongClickListener() {
            @Override
            public boolean onLongClick(View view) {
               //showChangeBTAddressDialog();
               return true;
            }
        });
        //btQRCode.setImageBitmap(QRCodeBitmapOfAndroidBtMacAddress);
        /*
        ImageView iv = (ImageView) view.findViewById(R.id.imageView);
        ImageView iv2 = (ImageView) view.findViewById(R.id.imageView2);
        Drawable vectorDrawable = VectorDrawableCompat.create(
                getResources(),
                R.drawable.ic_baseline_looks_one_24px,
                null);
        Drawable drawable = DrawableCompat.wrap(vectorDrawable);
        iv.setImageDrawable(drawable);

        vectorDrawable = VectorDrawableCompat.create(
                getResources(),
                R.drawable.ic_baseline_looks_two_24px,
                null);
        drawable = DrawableCompat.wrap(vectorDrawable);
        iv2.setImageDrawable(drawable);
        */
    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }
    @Override
    public void setUserVisibleHint(boolean isVisibleToUser) {
        super.setUserVisibleHint(isVisibleToUser);
        if(isVisibleToUser) {
            // Set title
            MainActivity.getInstance().setTitle(R.string.app_name);
            //BottomNavigationView navigation = (BottomNavigationView) MainActivity.getInstance().findViewById(R.id.bottomNavigationView);
            //navigation.setVisibility(View.GONE);
        }
    }

    @Override
    public void onResume() {
        super.onResume();
        MainActivity.getInstance().setTitle(R.string.app_name);
        //BottomNavigationView navigation = (BottomNavigationView ) MainActivity.getInstance().findViewById(R.id.bottomNavigationView);
        //navigation.setVisibility(View.GONE);
        /*
        Preference myPref = (Preference) findPreference("Factory Default");
        myPref.setOnPreferenceClickListener(new Preference.OnPreferenceClickListener() {
            public boolean onPreferenceClick(Preference preference) {
                //open browser or intent here


                MainActivity.ClearData();
                return true;
            }
        });
*/
    }
    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }
}

